// vi: set ts=4 sw=4 :
// vim: set tw=75 :

#include <extdll.h>			// always

#include <api_info.h>		// api_info_t, etc
#include <sdk_util.h>		// REG_SVR_COMMAND, etc
#include <meta_api.h>		// Plugin_info, etc
#include <cbase.h>

#include "statsme_api.h"		// me
#include "vers_plugin.h"			// COMPILE_TIME

cvar_t	*statsme_version;
cvar_t	*sm_logformat;
cvar_t	*sm_sayformat;
cvar_t	*sm_headshot;
cvar_t	*sm_bombset;
cvar_t	*sm_bombtimefreq;
cvar_t	*sm_bombtimecont;
cvar_t	*sm_kill;
cvar_t	*sm_monsterkill;
cvar_t	*sm_monsterkillnum;
cvar_t	*sm_roundend;
cvar_t	*sm_monsterfreq;
cvar_t	*sm_bombfreq;
cvar_t	*sm_bombcont;
cvar_t	*sm_playerstats;
cvar_t	*sm_weaponstats;
cvar_t	*sm_mode;

cvar_t	init_statsme_version=	{"statsme_version",VVERSION, FCVAR_SERVER | FCVAR_SPONLY};
cvar_t	init_sm_playerstats =   {"sm_playerstats","echo \"error: statsme.cfg not executed!\""};
cvar_t	init_sm_weaponstats =   {"sm_weaponstats","echo \"error: statsme.cfg not executed!\""};
cvar_t	init_sm_logformat	=	{"sm_logformat","error: statsme.cfg not executed!"};
cvar_t	init_sm_sayformat	=	{"sm_sayformat","200=100=0=-1=0.20=0=0.5=12=2.00=0.5=1"};
cvar_t	init_sm_mode		=	{"sm_mode","255",0,255};
cvar_t	init_sm_headshot =		{"sm_headshot","echo \"error: statsme.cfg not executed!\""};
cvar_t	init_sm_bombset =		{"sm_bombset","echo \"error: statsme.cfg not executed!\""};
cvar_t	init_sm_bombtimefreq =	{"sm_bombtimefreq","echo \"error: statsme.cfg not executed!\""};
cvar_t	init_sm_bombtimecont =	{"sm_bombtimecont","echo \"error: statsme.cfg not executed!\""};
cvar_t	init_sm_kill =			{"sm_kill","echo \"error: statsme.cfg not executed!\""};
cvar_t	init_sm_monsterkill =   {"sm_monsterkill","echo \"error: statsme.cfg not executed!\""};
cvar_t	init_sm_monsterkillnum ={"sm_monsterkillnum","3",0,3};
cvar_t	init_sm_roundend =		{"sm_roundend","echo \"error: statsme.cfg not executed!\""};
cvar_t	init_sm_monsterfreq =   {"sm_monsterfreq","3"};
cvar_t	init_sm_bombfreq =		{"sm_bombfreq","echo \"error: statsme.cfg not executed!\""};
cvar_t	init_sm_bombcont =		{"sm_bombcont","echo \"error: statsme.cfg not executed!\""};

void CmdSwitchStats()
{
	if (FStrEq(CMD_ARGV(1),"on"))	{
		sm_enabled = true;
		SERVER_PRINT("Statsme enabled\n");
	}
	else if (FStrEq(CMD_ARGV(1),"off"))	{
		sm_enabled = false;
		SERVER_PRINT("Statsme disabled\n");
	}
	else if (CMD_ARGC() > 1) {
		SERVER_PRINT(UTIL_VarArgs("statsme:   unknown parameter %s. 'on' and 'off' are vaild\n",CMD_ARGV(1)));
	}
	else {
		SERVER_PRINT("Usage:   statsme < on | off >\n");
		SERVER_PRINT(sm_enabled?"Statsme is enabled\n":"Statsme is disabled\n");
	}
}

//Type of running mod
short int	mod_id	  = MOD_UNKNOW;

// Plugin startup.  Register commands and cvars.
void statsme_init(void) {
	LOG_MESSAGE(PLID, "%s %s, %s", Plugin_info.name, Plugin_info.version, Plugin_info.date);
	LOG_MESSAGE(PLID, "by %s", Plugin_info.author);
	LOG_MESSAGE(PLID, "   http://%s/", Plugin_info.url);
	LOG_MESSAGE(PLID, "compiled: %s", __DATE__ ", " __TIME__);

	REG_SVR_COMMAND ("statsme", CmdSwitchStats);
	REG_SVR_COMMAND ("sm_say", CmdSay);
	REG_SVR_COMMAND ("sm_clexec", CmdClExec);

	CVAR_REGISTER (&init_statsme_version);
	CVAR_REGISTER (&init_sm_logformat);
	CVAR_REGISTER (&init_sm_sayformat);

	CVAR_REGISTER (&init_sm_roundend);
	CVAR_REGISTER (&init_sm_monsterkill);
	CVAR_REGISTER (&init_sm_monsterkillnum);
	CVAR_REGISTER (&init_sm_kill);
	CVAR_REGISTER (&init_sm_bombtimefreq);
	CVAR_REGISTER (&init_sm_bombtimecont);
	CVAR_REGISTER (&init_sm_bombset);
	CVAR_REGISTER (&init_sm_headshot);
	CVAR_REGISTER (&init_sm_monsterfreq);
	CVAR_REGISTER (&init_sm_bombfreq);
	CVAR_REGISTER (&init_sm_bombcont);

	CVAR_REGISTER (&init_sm_playerstats);
	CVAR_REGISTER (&init_sm_weaponstats);
	CVAR_REGISTER (&init_sm_mode);

	statsme_version=CVAR_GET_POINTER("statsme_version");
	sm_mode=CVAR_GET_POINTER("sm_mode");
	sm_playerstats=CVAR_GET_POINTER("sm_playerstats");
	sm_weaponstats=CVAR_GET_POINTER("sm_weaponstats");
	sm_logformat=CVAR_GET_POINTER("sm_logformat");
	sm_sayformat=CVAR_GET_POINTER("sm_sayformat");
	sm_headshot=CVAR_GET_POINTER("sm_headshot");
	sm_bombset=CVAR_GET_POINTER("sm_bombset");
	sm_bombtimefreq=CVAR_GET_POINTER("sm_bombtimefreq");
	sm_bombtimecont=CVAR_GET_POINTER("sm_bombtimecont");
	sm_kill=CVAR_GET_POINTER("sm_kill");
	sm_monsterkill=CVAR_GET_POINTER("sm_monsterkill");
	sm_monsterkillnum=CVAR_GET_POINTER("sm_monsterkillnum");
	sm_roundend=CVAR_GET_POINTER("sm_roundend");
	sm_bombfreq=CVAR_GET_POINTER("sm_bombfreq");
	sm_bombcont=CVAR_GET_POINTER("sm_bombcont");
	sm_monsterfreq=CVAR_GET_POINTER("sm_monsterfreq");
	
	memset(&players,0,sizeof(players));
	memset(&score,0,sizeof(score));
	memset(&weapon_select,0,sizeof(weapon_select));

	char game_dir[256];// find the directory name of the currently running MOD...
	char mod_name[32];

	GET_GAME_DIR(game_dir);

	int pos = strlen(game_dir) - 1;

	while (pos && game_dir[pos] != '/') 
		--pos;// scan backwards till first directory separator...

	strcpy(mod_name, &game_dir[++pos]);
	
	struct mod_info_t { 
		char name[16]; 
		short int id; 
	} pSelect[] = {
		//{"tfc",MOD_TFC},
		{"cstrike",MOD_CSTRIKE},
		//{"frontline",MOD_FLF},
		//{"dmc",MOD_DMC},
		{"dod",MOD_DOD},
		//{"firearms",MOD_FIREARMS},	
		//{"action",MOD_ACTION},
		//{"value",MOD_VALVE},
		{"",MOD_UNKNOW}
	};
	
	int index = 0;

	while (pSelect[index].name[0] && strcmpi(mod_name, pSelect[index].name))
		++index;

	mod_id = pSelect[index].id;
}

/*Used to fill string with info which is requested:*/
char* UTIL_FillWithInfo(const char* string)
{
	static char log_message[1024];
	static int len; len = 0;
	
	if(string){
		while (*string){
			if (*string == '%') {
				switch(*(string + 1)){
				case 'W':{
					const char* value = score.weapon;
					while (value && *value)	{
						log_message[len++] = *value++;
					}
					string+=2;
					continue;
				}
				case 'B':{
					const char* value = STRING(score.bombplanter);
					while (value && *value)	{
						log_message[len++] = *value++;
					}
					string+=2;
					continue;
				}
				case 'M':{
					const char* value = STRING(score.killer);
					while (value && *value)	{
						log_message[len++] = *value++;
					}
					string+=2;
					continue;
				}
				case 'V':{
					const char* value = STRING(score.victim);
					while (value && *value)	{
						log_message[len++] = *value++;
					}
					string+=2;
					continue;
				}
				case 'K': case '1': {
					const char* value = UTIL_VarArgs("%d",score.kills);
					while (value && *value)	{
						log_message[len++] = *value++;
					}
					string+=2;
					continue;
				}
				case 'H':{
					const char* value = UTIL_VarArgs("%d",score.heads);
					while (value && *value)	{
						log_message[len++] = *value++;
					}
					string+=2;
					continue;
				}
				case 'C':{
					const char* value = UTIL_VarArgs("%d",score.game_score[2]);
					while (value && *value)	{
						log_message[len++] = *value++;
					}
					string+=2;
					continue;
				}
				case 'T':{
					const char* value = UTIL_VarArgs("%d",score.game_score[1]);
					while (value && *value)	{
						log_message[len++] = *value++;
					}
					string+=2;
					continue;
				}
				case 'E':{
					const char* value = score.mp_c4word;
					while (value && *value)	{
						log_message[len++] = *value++;
					}
					string+=2;
					continue;
				}
				case 'F':{
					const char* value = UTIL_VarArgs("%d",score.mp_c4timer);
					while (value && *value)	{
						log_message[len++] = *value++;
					}
					string+=2;
					continue;
				}
				case '2':{
					const char* value = UTIL_VarArgs("%d",score.deaths);
					while (value && *value)	{
						log_message[len++] = *value++;
					}
					string+=2;
					continue;
				}
				case '3':{
					const char* value = UTIL_VarArgs("%.2f",score.killstodeaths);
					while (value && *value)	{
						log_message[len++] = *value++;
					}
					string+=2;
					continue;
				}
				case '4':{
					const char* value = UTIL_VarArgs("%.2f",score.accuracy);
					while (value && *value)	{
						log_message[len++] = *value++;
					}
					string+=2;
					continue;
				}

				}/*switch*/
			}
			else if (*string == '\\')	{
				switch(*(string + 1)){
				case '\\':
					log_message[len++] = *(string+1);
					log_message[len++] = *(string+2);
					string+=3;
					continue;
				case 'n':
					log_message[len++] = '\n';
					string+=2;
					continue;
				case '%':
					log_message[len++] = '%';
					string+=2;
					continue;
				case '\'':
					log_message[len++] = '\"';
					string+=2;
					continue;
				}
			}
			
			log_message[len++] = *string++;
		}
	}
	
	log_message[len]='\0';
	return log_message;
}

char *UTIL_FillWithWeapon(const char* log_format, const char* wname, weapon_stat_t& a_weapons)
{
	static char log_message[512];
	int len=0,c=0;
	static char value_s[32];
	static char* value;
	
	if (log_format){
		while (*log_format){
			if (*log_format == '%')	{
				switch(*(log_format + 1)){
				case 'w':{
					while (wname && *wname)	{
						log_message[len++] = *wname;
						wname++;
					}
					log_format+=2;
					continue;
						 }
				case 's':{
					sprintf(value_s,"%d", a_weapons.bulletsfired);
					value = value_s;
					while (value && *value)	{
						log_message[len++] = *value++;
					}
					log_format+=2;
					continue;
						 }
				case 'h':{
					sprintf(value_s,"%d", a_weapons.headshot);
					value = value_s;
					while (value && *value)	{
						log_message[len++] = *value++;
					}
					log_format+=2;
					continue;
						 }
				case 'a':{
					sprintf(value_s,"%d", a_weapons.bulletshit);
					value = value_s;
					while (value && *value)	{
						log_message[len++] = *value++;
					}
					log_format+=2;
					continue;
						 }
				case 'k':{
					sprintf(value_s,"%d", a_weapons.kills);
					value = value_s;
					while (value && *value)	{
						log_message[len++] = *value++;
					}
					log_format+=2;
					continue;
						 }
				case 't':{
					sprintf(value_s,"%d", a_weapons.tk);
					value = value_s;
					while (value && *value)	{
						log_message[len++] = *value++;
					}
					log_format+=2;
					continue;
						 }
				case 'f':{
					sprintf(value_s,"%d", a_weapons.health);
					value = value_s;
					while (value && *value)	{
						log_message[len++] = *value++;
					}
					log_format+=2;
					continue;
						 }
				case 'd':{
					sprintf(value_s,"%d", a_weapons.deaths);
					value = value_s;
					while (value && *value)	{
						log_message[len++] = *value++;
					}
					log_format+=2;
					continue;
						 }
				case '6':{
					float accuracy = ACCURACY_FORMULA(a_weapons.bulletsfired,a_weapons.bulletshit);
					sprintf(value_s,"%.2f", accuracy);
					value = value_s;
					while (value && *value)	{
						log_message[len++] = *value++;
					}
					log_format+=2;
					continue;
						 }
				case '7':{
					float dtratio = EFFEC_FORMULA(a_weapons.kills,a_weapons.deaths);
					sprintf(value_s,"%.2f", dtratio);
					value = value_s;
					while (value && *value)	{
						log_message[len++] = *value++;
					}
					log_format+=2;
					continue;
						 }
					
					
				}/*switch*/
			}
			else if (*log_format == '\\')	{
				switch(*(log_format + 1)){
				case '\\':
					log_message[len++] = *(log_format+1);
					log_message[len++] = *(log_format+2);
					log_format+=3;
					continue;
				case 'n':
					log_message[len++] = '\n';
					log_format+=2;
					continue;
				case '%':
					log_message[len++] = '%';
					log_format+=2;
					continue;
				case '\'':
					log_message[len++] = '\"';
					log_format+=2;
					continue;
				}
			}
			
			log_message[len++] = *log_format++;
		}
	}
	log_message[len]='\0';
	return log_message;
}

char* UTIL_VarArgs( char *format, ... )
{
	va_list		argptr;
	static char		string[1024];
	
	va_start (argptr, format);
	vsprintf (string, format,argptr);
	va_end (argptr);

	return string;
}

//=========================================================
// UTIL_LogPrintf - Prints a logged message to console.
// Preceded by LOG: ( timestamp ) < message >
//=========================================================
void UTIL_LogPrintf( char *fmt, ... )
{
	va_list			argptr;
	static char		string[1024];
	
	va_start ( argptr, fmt );
	vsprintf ( string, fmt, argptr );
	va_end   ( argptr );

	// Print to server console
	ALERT( at_logged, "%s", string );
}

int gmsgMOTD		= 0;
int gmsgServerName	= 0;

#define MAX_MOTD_CHUNK	  60
#define MAX_MOTD_LENGTH   1024

void UTIL_ShowMOTD( edict_t *client , char *pList, const char *szName)
{
	// send szName
	MESSAGE_BEGIN( MSG_ONE, gmsgServerName, NULL, client );
		WRITE_STRING(szName);
	MESSAGE_END();

	char	chunk[MAX_MOTD_CHUNK+1];
	char	*aList = pList;
	int		ch_count = 0;

	while ( pList && *pList && ch_count < MAX_MOTD_LENGTH )
	{
		if ( strlen( pList ) < MAX_MOTD_CHUNK ) {
			strcpy( chunk, pList );
		}
		else {
			strncpy( chunk, pList, MAX_MOTD_CHUNK );
			chunk[MAX_MOTD_CHUNK] = 0;
		}

		ch_count += strlen( chunk );

		if ( ch_count < MAX_MOTD_LENGTH ) {
			pList = aList + ch_count; 
		}
		else {
			*pList = 0;
		}

		MESSAGE_BEGIN( MSG_ONE, gmsgMOTD, NULL, client );
			WRITE_BYTE( *pList ? FALSE : TRUE );// FALSE means there is still more message to come
			WRITE_STRING( chunk );
		MESSAGE_END();
	}

	// back server name
	MESSAGE_BEGIN( MSG_ONE, gmsgServerName, NULL, client );
		WRITE_STRING(CVAR_GET_STRING("hostname"));
	MESSAGE_END();
}

unsigned short FixedUnsigned16( float value, float scale )
{
	int output;
	output = value * scale;
	if ( output < 0 )
		output = 0;
	if ( output > 0xFFFF )
		output = 0xFFFF;
	return (unsigned short)output;
}

short FixedSigned16( float value, float scale )
{
	int output;
	output = value * scale;
	if ( output > 32767 )
		output = 32767;
	if ( output < -32768 )
		output = -32768;
	return (short)output;
}

void UTIL_HudMessage(const hudtextparms_t &textparms, char *pMessage)
{	

	MESSAGE_BEGIN(MSG_BROADCAST, SVC_TEMPENTITY, NULL);
	WRITE_BYTE(29); 
	WRITE_BYTE(textparms.channel & 0xFF); 
	WRITE_SHORT(FixedSigned16(textparms.x, (1<<13) ));
	WRITE_SHORT(FixedSigned16(textparms.y, (1<<13) ));
	WRITE_BYTE(textparms.effect);
	WRITE_BYTE(textparms.r1);
	WRITE_BYTE(textparms.g1);
	WRITE_BYTE(textparms.b1);
	WRITE_BYTE(200);
	WRITE_BYTE(textparms.r1);
	WRITE_BYTE(textparms.g1);
	WRITE_BYTE(textparms.b1);
	WRITE_BYTE(200);
	WRITE_SHORT(FixedUnsigned16(textparms.fadeinTime, (1<<8) ));
	WRITE_SHORT(FixedUnsigned16(textparms.fadeoutTime, (1<<8) ));
	WRITE_SHORT(FixedUnsigned16(textparms.holdTime, (1<<8) ));

	if ( textparms.effect == 2 )
		WRITE_SHORT(FixedUnsigned16(textparms.fxTime, (1<<8) ) );
	
	static char bMessage[192];
	int current = 0; //Source position
	int len = 0; //Over all length
	int line_len = 0; //Line length
	int new_len = 0; //Length from last space
	int last_space = -1; //Place of last place
	//Go throw tekst and move to new line if needed

	while ( pMessage[len] && len < 190) {
		if (pMessage[len] == ' ' && len < 70) {
			last_space = len;	
			new_len = 0;
		}
		if (pMessage[len] == '\n') {
			line_len = 1; 
			last_space = -1;
			//++num_of_nl;
		}

		bMessage[len++] = pMessage[current++];
		line_len++;	new_len++;

		if (line_len > 69) {
			if (last_space == -1) {
				bMessage[len++] = '\n';
				line_len = 0;
				//++num_of_nl;
			}
			else {
				bMessage[last_space] = '\n';
				line_len = new_len;
				//++num_of_nl;
			}
			last_space = -1;
		}
	}

	bMessage[len] = '\0';
	WRITE_STRING(bMessage);
	MESSAGE_END();
}

void CmdSay(void)
{
	//r:g:b:effect:fxTime:holdtime:fadeinTime:fadoutTime:x:y
	if (CMD_ARGC() > 1){
		//if faild it will be "200:100:0:-1:0.20:0:0.5:12:0.02:2.0"
		int r=200,g=100,b=0;
		float x=-1.0,y=0.25;
		int effect=1, channel = 1;
		float fxTime=0.5,holdTime=12.0,fadeinTime=0.02,fadeoutTime=2.0;

		sscanf (sm_sayformat->string,"%d%*1s%d%*1s%d%*1s%f%*1s%f%*1s%d%*1s%f%*1s%f%*1s%f%*1s%f%*1s%d",
			&r,&g,&b,&x,&y,&effect,&fxTime,&holdTime,&fadeinTime,&fadeoutTime, &channel);

		hudtextparms_t hudtextparm;
		hudtextparm.a1 = 0;
		hudtextparm.a2 = 0;

		hudtextparm.r2 = 255;
		hudtextparm.g2 = 255;
		hudtextparm.b2 = 250;

		hudtextparm.r1 = r;
		hudtextparm.g1 = g;
		hudtextparm.b1 = b;

		hudtextparm.effect = effect;
		hudtextparm.holdTime = holdTime;
		hudtextparm.fadeoutTime = fadeoutTime;
		hudtextparm.fadeinTime = fadeinTime;
		hudtextparm.x = x, hudtextparm.y = y;
		hudtextparm.fxTime = fxTime;
		hudtextparm.channel = channel;

		char* msg = (char*)CMD_ARGS();

		if (*msg == '\"') {
			msg = &msg[1];
			int len = strlen(msg)-1;
			if (msg[len]=='\"')
				msg[len] = '\0';
		}

		UTIL_HudMessage(hudtextparm, UTIL_FillWithInfo(msg));
	}
	else{
		SERVER_PRINT("Usage:  sm_say < message >\n");
	}
}

void CmdClExec(void)
{
	if (CMD_ARGC() > 2)
	{
		const char* object = CMD_ARGV(1);

		int who_catch = 1;//1 - WONID, 2 - USERID, 3 - ALL PLAYERS

		int index = 0;
		
		if (*object=='#' && *(object+1)) 
		{
			index =	atoi(object+1);

			who_catch = 2;
		} 
		else if (*object=='*' && *(object+1)=='\0') 
		{
			who_catch = 3;
		}
		else 
		{
			index = atoi(object);
		}
		
		player_t *pPlayer = NULL;
		
		for (int i = 1; i <= gpGlobals->maxClients;++i)	
		{
			pPlayer = GET_PLAYER_POINTER_I(i);
			
			if(pPlayer->valid)
			{
				if (who_catch==1) 
				{
					if (index != (int)GETPLAYERWONID( pPlayer->pEdict ))
						continue;
				}
				else if (who_catch==2)
				{
					if (index != GETPLAYERUSERID( pPlayer->pEdict ))
						continue;
				}
				
				CLIENT_COMMAND(pPlayer->pEdict,"%s\n", UTIL_FillWithInfo((char*)CMD_ARGV(2)));
				
				if (who_catch != 3)
					break;
			}
		}
		
	}
	else{
		SERVER_PRINT("Usage:  sm_clexec < * | #userid | wonid > < command >\n");
	}
}

void UTIL_IntToString(int value, char *output)
{
	static const char number10[9][12] = {"eleven ","twelve ",
		"thirteen ","fourteen ","fifteen ","sixteen ","seventeen ","eighteen ","nineteen "};

	static const char number20[8][12] = {"twenty ","thirty ","fourty ", 
		"fifty ","sixty ","seventy ","eighty ","ninety "};

	static const char number1[10][12] = {"one ","two ","three ","four ","five ", 
		"six ","seven ","eight ","nine ","ten "};

	int i, num = value; output[0]=0;

	if (num > 19)	{
		num = value / 10;
		for (i = 0; i < 8; i++){
			if (num == i + 2){
				strcpy(output, number20[i]);
				break;
			}
		}
		int x = value - (num*10);	
		for (i = 0; i < 10; i++){
			if (x == i + 1)	{
				strcat(output, number1[i]);
				break;
			}
		}
	}
	else if (num < 11) {
		for (i = 0; i < 10; i++){
			if (num == i + 1){
				strcpy(output, number1[i]);
				break;
			}
		}
	}
	else {	
		for (i = 0; i < 9; i++){
			if (num == i + 11){
				strcpy(output, number10[i]);
				break;
			}
		}
	}
}