// vi: set ts=4 sw=4 :
// vim: set tw=75 :

#include <extdll.h>			// always

#include <api_info.h>		// api_info_t, etc
#include <sdk_util.h>		// REG_SVR_COMMAND, etc
#include <meta_api.h>		// Plugin_info, etc
#include <cbase.h>

#include "statsme_api.h"		// me
#include "vers_plugin.h"			// COMPILE_TIME

weapon_select_struct weapon_select[MAX_WEAPONS+1];

struct end_msg_t {
	char end_msg[36];
	short int team;
} end_msg[15] = {
	{"#Terrorists_Win",1},
	{"#CTs_Win",2},
	{"#Bomb_Defused",2},
	{"#Target_Bombed",1},
	{"#Target_Saved",2},
	{"#All_Hostages_Rescued",2},
	{"#Round_Draw",0},
	{"#VIP_Assassinated",1},
	{"#Terrorist_Escaped",1},
	{"#VIP_Not_Escaped",1},
	{"#Terrorists_Not_Escaped",2},
	{"#Hostages_Not_Rescued",1},
	{"#Escaping_Terrorists_Neutralized",2},
	{"#CTs_PreventEscape",2},
	{"#VIP_Escaped",2}
};

void Client_TeamInfo(void *p, player_t *pPlayer)
{	
	static int index = 0;
	
	switch (client_state++) {
	case 0:
		
		index = *(int *)p;
		
		break;
		
	case 1:

		strcpy(players[index].team_name,(char *)p);
		players[index].pEdict = INDEXENT(index);

		break;
	}
}

void Client_WeaponList(void *p, player_t *pPlayer)
{
	static int counter = 0;
	static int weapon_list = 0;
	static int weapon_id = 0;
	static const char* wpn_name;	

	switch (client_state++) {
	case 0:

		wpn_name = (char *)p;
		break;

	case 7:

		weapon_id = *(int *)p;

		if (weapon_list & (1<<weapon_id))
			break;

		weapon_list |= (1<<weapon_id); //Save this weapon

		weapon_select[counter].iId = weapon_id;

		//trunk "weapon_" from name (7 chars)
		strcpy(weapon_select[counter++].name, (wpn_name + 7) ); 

	}	
}

void Client_TextMsg(void *p, player_t *pPlayer)
{
	static const char *szText = NULL;
	
	switch (client_state++) {
	case 1:
		
		szText = (char *)p;
		
		if (FStrEq("#Game_will_restart_in",szText))
		{
			memset(&score,0,sizeof(score));
		}
		else if (FStrEq("#Bomb_Planted",szText))
		{
			if (score.mp_c4timer != -1){
				score.mp_c4timer = (int)CVAR_GET_FLOAT("mp_c4timer") + 1;
				score.bomb_time	 = 0.0;
			}

			if (SM_MODE(BOMB_ON)){
				//sm_say \'%B set us up the bomb!!!\'
				DO_THE_ACTION(sm_bombset->string);
			}
		}
		else {
			
			for (int i = 0; i < 15; ++i)
			{
				if (FStrEq(end_msg[i].end_msg, szText))
				{
					score.mp_c4timer = -1; //Stop bomb counting down
					score.bomb_time  = 0.0;
					
					score.game_score[end_msg[i].team]++; //Score team (CT or T)
					
					//Now say who is the best!!!
					int who_is_the_man = 0;
					score.kills = 0;
					score.heads = 0;
					int i;
					
					for (i = 1; i <= gpGlobals->maxClients ; ++i){
						if (score.kills < score.bestkill[i])
						{	
							score.kills = score.bestkill[i];
							score.heads = score.besths[i];
							who_is_the_man = i;
						}
						else if ((score.kills==score.bestkill[i])&&score.heads<score.besths[i])
						{
							score.kills = score.bestkill[i];
							score.heads = score.besths[i];
							who_is_the_man = i;
						}
					}
					
					for (i = 0; i < 33; ++i){
						score.besths[i]=0;
						score.bestkill[i]=0;
					}
					
					if (SM_MODE(ROUND_ON) && who_is_the_man){
						score.killer = INDEXENT(who_is_the_man)->v.netname;
						//sm_say \'Best killer: %M\\nwith %K kills (%H headshots)\\nScore: CT %C -- T %T\'
						DO_THE_ACTION(sm_roundend->string);
					}
					
					break;
				}/*switch*/
			}/*for*/
		}/*else if*/
	}
}

void Client_StatusIcon(void *p, player_t *pPlayer)
{
	static int iState = 0;
	static const char *szIcon = NULL;
	
	switch (client_state++) {
	case 0:
		
		iState = *(int *)p;
		
		break;
	case 1:
		
		szIcon = (char *)p;
		
		if (szIcon[0] == 'c' && szIcon[1] == '4' && !szIcon[2] && iState==2)
			score.bombplanter = pPlayer->pEdict->v.netname;
		
	}
}

void Client_CurWeapon(void *p, player_t *pPlayer)
{
	static int iState = 0;
	static int iClip = 0;
	static int iId = 0;
		
	switch (client_state++) {
	case 0:

		iState = *(int *)p;

		break;
	case 1:

		if (iState){
			iId = *(int *)p;
			pPlayer->current_weapon = iId; // weapon ID
		}
		
		break;

	case 2:

		if (iState){

			iClip = *(int *)p;
				
			if (iClip > -1 && iClip < pPlayer->a_weapons[iId].lastammo)
				++pPlayer->a_weapons[iId].bulletsfired;

			pPlayer->a_weapons[iId].lastammo = iClip;

			
		}
	}
}

void Client_DeathMsg(void *p, player_t *pPlayer)
{	
	static char*	szWeapon = NULL;
	static bool		bHeadShot = false;

	static int		iKiller = 0;
	static player_t *pKiller = NULL;
	static int		iVictim = 0;
	static player_t *pVictim = NULL;

	switch (client_state++){

	case 0:

		iKiller = *(int *)p;
		pKiller = (iKiller<1||iKiller>32) ? NULL : GET_PLAYER_POINTER_I(iKiller);

		break;

	case 1:

		iVictim = *(int *)p;
		pVictim = (iVictim<1||iVictim>32) ? NULL : GET_PLAYER_POINTER_I(iVictim);

	case 2:

		bHeadShot = (*(int *)p) ? true: false ;

		break;

	case 3:

		if (pKiller && pVictim) {
	
			szWeapon = (char*)p;
			
			for (int i = 0; weapon_select[i].iId; ++i)
			{
				if (FStrEq(szWeapon,weapon_select[i].name))
				{
					if (bHeadShot){
						pKiller->a_weapons[weapon_select[i].iId].headshot++;
					}
					
					pKiller->a_weapons[weapon_select[i].iId].kills++;
					
					if (FStrEq(pKiller->team_name, pVictim->team_name))
					{
						pKiller->a_weapons[weapon_select[i].iId].tk++;
					}
					else 
					{
						pKiller->kills++;
						pVictim->deaths++;
					}
					
					break; //Nothing else to do here
				}
			}

			pVictim->a_weapons[pVictim->current_weapon].deaths++;

			score.bestkill[iKiller]++;/*for end round stats*/
			score.freqkill[iKiller]++;/*for monsterkill*/
			
			if (bHeadShot)	{
				score.besths[iKiller]++;
				score.freqhs[iKiller]++;
			}

			score.killer = pKiller->pEdict->v.netname;
			score.victim = pVictim->pEdict->v.netname;

			score.weapon = szWeapon;

			pKiller->freqtime = gpGlobals->time + sm_monsterfreq->value;
			
			if (SM_MODE(HEAD_ON) && bHeadShot){
				//sm_say \'%M made headshot\\non %V with %W!\'
				DO_THE_ACTION(sm_headshot->string);
			}			
			else if (SM_MODE(KILL_ON) && (pKiller != pVictim)) {
				//sm_say \'%M killed %V\\nwith %W!\'
				DO_THE_ACTION(sm_kill->string);
			}						
		}
	}
}

void Client_Damage(void *p, player_t *pPlayer)
{

	// types of damage to ignore...
	static int IGNORE_DAMAGE = (DMG_FALL|DMG_CRUSH|DMG_FREEZE|DMG_SHOCK\
		|DMG_DROWN|DMG_NERVEGAS|DMG_RADIATION|DMG_DROWNRECOVER|\
		DMG_ACID|DMG_SLOWBURN|DMG_SLOWFREEZE);

	static int damage_taken		= 0;
	static int damage_bits		= 0;  // type of damage being done
	static int health			= 0;
	static edict_t *pEnemy		= NULL; 

	switch (client_state++) {
	case 1:	

		damage_taken = *(int *)p;

		break;
	case 2:

		damage_bits = *(int *)p;
		
		if (damage_bits & IGNORE_DAMAGE) 
			break;// ignore certain types of damage...


		pEnemy = pPlayer->pEdict->v.dmg_inflictor;
		
		if (!pEnemy || !FClassnameIs(pEnemy,"player")) 
			break;
		
		if (damage_taken)
		{
			static player_t *pAttacker; pAttacker = GET_PLAYER_POINTER(pEnemy);
			pAttacker->a_weapons[pAttacker->current_weapon].health += damage_taken; 
			pAttacker->a_weapons[pAttacker->current_weapon].bulletshit++;
		}
	}
}